// backprop.cpp		Suresh kumar V. Rao, H. Rao

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "layer.h"


                 

#define TRAINING_FILE	"c:\\temo\\train\\training.dat"
#define WEIGHTS_FILE "c:\\temo\\train\\weights.dat"
#define OUTPUT_FILE	"c:\\temo\\train\\output.dat"
#define TEST_FILE	"c:\\temo\\train\\test.dat"

void __cdecl main()
{

FLOAT error_tolerance=0.1;
FLOAT total_error=0.0;
FLOAT avg_error_per_cycle=0.0;
FLOAT error_last_cycle=0.0;
FLOAT avgerr_per_pattern=0.0; // for the latest cycle
FLOAT error_last_pattern=0.0;
FLOAT learning_parameter=0.02;
FLOAT alpha; // momentum parameter
FLOAT NF; // noise factor
FLOAT new_NF;



/*
FLOAT test1[] = {-1,-1.2, .4, .5 };

//squashXMM(&test[0]);

float test = 50;

__int64 o;
const __int64 MAX_LOOP = 50000000;
unsigned int timer1 = GetTickCount();
for(o=0; o < MAX_LOOP; o++)
{
//	test =  (rand() % 15000 - 6000)/900.;
	test = 1/(1+exp(-test));
}

timer1= GetTickCount() - timer1;

unsigned int timer2 = GetTickCount();
for(o=0; o < MAX_LOOP; o++)
{
	//test =  (rand() % 15000 -6000)/900.;
    squashXMM(&test1[0]);


}
 */

/*
double error =0.0;
float test;
double val1,val2;
const int MAXLOOP = 5000000;
for(int o; o < MAXLOOP;  o++)
{
	
	test =  (rand() % 15000 - 6000)/900.;
	val1 = 1/(1+exp(-test));
	val2 = squash2(test);
	error +=  (val1-val2)*(val1-val2);
}
*/

//timer2= GetTickCount() - timer2;
/*unsigned  int timer3 = GetTickCount();
for(o=0; o < MAX_LOOP; o++)
{
	test =  (rand() % 15000 -6000)/900.;
}
timer3 = (GetTickCount() - timer3);*/
/*
int timer3 =0;


cout << " Operations 1 = "  <<  timer1 - timer3;
cout << " Operations 2 = "  <<  timer2 - timer3;
cout << " Operations 2 = "  <<  timer3;
*/
/*
cout << "Error =" << sqrt(error  / MAXLOOP);


return;
*/


unsigned temp, startup, start_weights;
int vectors_in_buffer;
int max_cycles;
int patterns_per_cycle=0;

__int64 total_cycles, total_patterns;
int i; 


// create a network object
network backp;


FILE * training_file_ptr, * weights_file_ptr, * output_file_ptr;
FILE * test_file_ptr, * data_file_ptr;
                                            
// open output file for writing
if ((output_file_ptr=fopen(OUTPUT_FILE,"w"))==NULL)
		{
		cout << "problem opening output file\n";
		exit(1);
		}

// enter the training mode : 1=training on     0=training off
cout << "---------------------------------------------------\n";
cout << " C++ Neural Networks and Fuzzy Logic \n";
cout << " 	Backpropagation simulator \n";
cout << "		version 2 \n";
cout << "---------------------------------------------------\n";
cout << "Please enter 1 for TRAINING on, or 0 for off: \n\n";
cout << "Use training to change weights according to your\n";
cout << "expected outputs. Your training.dat file should contain\n";
cout << "a set of inputs and expected outputs. The number of\n";
cout << "inputs determines the size of the first (input) layer\n";
cout << "while the number of outputs determines the size of the\n";
cout << "last (output) layer :\n\n";

cin >> temp;
backp.set_training(temp);

if (backp.get_training_value() == 1)
	{
	cout << "--> Training mode is *ON*. weights will be saved\n";
	cout << "in the file weights.dat at the end of the\n";
	cout << "current set of input (training) data\n";
	}
else
	{
	cout << "--> Training mode is *OFF*. weights will be loaded\n";
	cout << "from the file weights.dat and the current\n";
	cout << "(test) data set will be used. For the test\n";
	cout << "data set, the test.dat file should contain\n";
	cout << "only inputs, and no expected outputs.\n";
	}

if (backp.get_training_value()==1)
	{
	// -----------------------------------------
	// 	Read in values for the error_tolerance, 
	//	and the learning_parameter
	// -----------------------------------------
	cout << " Please enter in the error_tolerance\n";
	cout << " --- between 0.001 to 100.0, try 0.1 to start --\n";
	cout << "\n";
	cout << "and the learning_parameter, beta\n";
	cout << " --- between 0.01 to 1.0, try 0.5 to start -- \n\n";
	cout << " separate entries by a space\n";
	cout << " example: 0.1 0.5 sets defaults mentioned :\n\n";

	cin >> error_tolerance >> learning_parameter;

	error_tolerance*=error_tolerance;

	// -----------------------------------------
	// 	Read in values for the momentum 
	//	parameter, alpha (0-1.0)
	//	and the noise factor, NF (0-1.0)
	// -----------------------------------------
	cout << "Enter values now for the momentum \n";
	cout << "parameter, alpha(0-1.0)\n";
	cout << " and the noise factor, NF (0-1.0)\n";
	cout << "You may enter zero for either of these\n";
	cout << "parameters, to turn off the momentum or\n";
	cout << "noise features.\n";
	cout << "If the noise feature is used, a random\n";
	cout << "component of noise is added to the inputs\n";
	cout << "This is decreased to 0 over the maximum\n";
	cout << "number of cycles specified.\n";
	cout << "enter alpha followed by NF, e.g., 0.3 0.5\n";

	cin >> alpha >> NF;

	//-------------------------------------------
	// open training file for reading
	//-------------------------------------------
	if ((training_file_ptr=fopen(TRAINING_FILE,"r"))==NULL)
		{
		cout << "problem opening training file\n";
		exit(1);
		}
	data_file_ptr=training_file_ptr; // training on

	// Read in the maximum number of cycles
	// each pass through the input data file is a cycle
	cout << "Please enter the maximum cycles for the simulation\n";
	cout << "A cycle is one pass through the data set.\n";
	cout << "Try a value of 10 to start with\n";

	cin >> max_cycles;

	cout << "Do you want to read weights from weights.dat to start?\n";
	cout << "Type 1 to read from file, 0 to randomize starting weights\n";
	cin >> start_weights;

	}
else
	{
	if ((test_file_ptr=fopen(TEST_FILE,"r"))==NULL)
		{
		cout << "problem opening test file\n";
		exit(1);
		}

	data_file_ptr=test_file_ptr; // training off
	}




// training: continue looping until the total error is less than
// 		the tolerance specified, or the maximum number of
// 		cycles is exceeded; use both the forward signal propagation
// 		and the backward error propagation phases. If the error
//		tolerance criteria is satisfied, save the weights in a file.
// no training: just proceed through the input data set once in the
// 		forward signal propagation phase only. Read the starting
//		weights from a file.
// in both cases report the outputs on the screen


// intialize counters
total_cycles=0; // a cycle is once through all the input data
total_patterns=0; // a pattern is one entry in the input data
new_NF=NF;


// get layer information
backp.get_layer_info();

// set up the network connections
backp.set_up_network();

// initialize the weights
if ((backp.get_training_value()==1)&&(start_weights!=1))
	{
	// randomize weights for all layers; there is no
	// weight matrix associated with the input layer
	// weight file will be written after processing

	backp.randomize_weights();
	// set up the noise factor value
	backp.set_NF(new_NF);
	}
else
	{
	// read in the weight matrix defined by a
	// prior run of the backpropagation simulator
	// with training on
	if ((weights_file_ptr=fopen(WEIGHTS_FILE,"r"))
			==NULL)
		{
		cout << "problem opening weights file\n";
		exit(1);
		}
	backp.read_weights(weights_file_ptr);
	fclose(weights_file_ptr);
	}




// main loop
// if training is on, keep going through the input data
// 		until the error is acceptable or the maximum number of cycles
// 		is exceeded.
// if training is off, go through the input data once. report outputs
// with inputs to file output.dat

startup=1;
vectors_in_buffer = MAX_VECTORS; // startup condition
total_error = 0; 


while (			((backp.get_training_value()==1) 
			&& (avgerr_per_pattern
					> error_tolerance)
			&& (total_cycles < max_cycles)
			&& (vectors_in_buffer !=0))
			|| ((backp.get_training_value()==0) 
			&& (total_cycles < 1))
			|| ((backp.get_training_value()==1)
			&& (startup==1))
			)
{
startup=0;
error_last_cycle=0; // reset for each cycle
patterns_per_cycle=0;

backp.update_momentum(); // added to reset
			// momentum matrices
			// each cycle

// process all the vectors in the datafile
// going through one buffer at a time
// pattern by pattern



while ((vectors_in_buffer==MAX_VECTORS))
	{
vectors_in_buffer=
		backp.fill_IObuffer(data_file_ptr); // fill buffer
	//vectors_in_buffer=
	//	backp.fill_IObuffer(data_file_ptr); // fill buffer
		if (vectors_in_buffer < 0)
			{
			cout << "error in reading in vectors, aborting\n";
			cout << "check that there are on extra linefeeds\n";
			cout << "in your data file, and that the number\n";
			cout << "of layers and size of layers match the\n";
			cout << "the parameters provided.\n";
			exit(1);
			}

		// process vectors
		for (i=0; i<vectors_in_buffer; i++)
			{
			// get next pattern
			backp.set_up_pattern(i);

			total_patterns++;
			patterns_per_cycle++;
			// forward propagate

			backp.forward_prop();

			if (backp.get_training_value()==0)
				backp.write_outputs(output_file_ptr);

			// back_propagate, if appropriate
			if (backp.get_training_value()==1)
				{

				backp.backward_prop(error_last_pattern);
				error_last_cycle += 
					error_last_pattern*error_last_pattern;
				avgerr_per_pattern = error_last_cycle / patterns_per_cycle;
		
					
				// if it's not the last cycle, update weights
				if ((avgerr_per_pattern > error_tolerance)	&& 
					(total_cycles+1 < max_cycles))
				
				
					backp.update_weights(learning_parameter,
						alpha);              
				// backp.list_weights(); // can
				// see change in weights by 
				// using list_weights before and
				// after back_propagation
				

				}
				error_last_pattern = 0;


			}


	}

total_error += error_last_cycle;
total_cycles++;

// update NF        
// gradually reduce noise to zero        
if (total_cycles>0.7*max_cycles)
		new_NF = 0;
else	if (total_cycles>0.5*max_cycles)
			new_NF = 0.25*NF;
		else	if (total_cycles>0.3*max_cycles)
					new_NF = 0.50*NF;
				else	if (total_cycles>0.1*max_cycles)
							new_NF = 0.75*NF;
							
backp.set_NF(new_NF);

// most character displays are 25 lines
// user will see a corner display of the cycle count
// as it changes
/*
cout << "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";
cout << total_cycles << "\t" << avgerr_per_pattern << "\n";
 */

if(total_cycles % 100 == 0) {
	cout << (float) total_cycles << "\t" << sqrt((double)avgerr_per_pattern) << "\n";
	cout.flush();
}


fseek(data_file_ptr, 0L, SEEK_SET); // reset the file pointer
				// to the beginning of
				// the file
vectors_in_buffer = MAX_VECTORS; // reset

} // end main loop

if (backp.get_training_value()==1)
	{
	if ((weights_file_ptr=fopen(WEIGHTS_FILE,"w"))
			==NULL)
		{
		cout << "problem opening weights file\n";
		exit(1);
		}
	}

cout << "\n\n\n\n\n\n\n\n\n\n\n";
cout << "---------------------------------------------------\n";
cout << " 	done:	results in file output.dat\n";
cout << "		training: last vector only\n";
cout << "		not training: full cycle\n\n";
if (backp.get_training_value()==1)
	{
	backp.write_weights(weights_file_ptr);
	backp.write_outputs(output_file_ptr);
	avg_error_per_cycle=(FLOAT)sqrt((double)total_error/total_cycles);
	error_last_cycle=(FLOAT)sqrt((double)error_last_cycle);
	fclose(weights_file_ptr);

cout << "		weights saved in file weights.dat\n";
cout << "\n";
cout << "---->average error per cycle = " << avg_error_per_cycle << " <---\n";
cout << "---->error last cycle = " << error_last_cycle << " <---\n";
cout << "->error last cycle per pattern= " <<sqrt(avgerr_per_pattern) << " <---\n";

	}

cout << "------------>total cycles = " << (float) total_cycles << " <---\n";
cout << "------------>total patterns = " << (float) total_patterns << " <---\n";
cout << "---------------------------------------------------\n";
// close all files
fclose(data_file_ptr);
fclose(output_file_ptr);

}