/***************************************************************************
 * blitz/alg/radius.cc     
 * helper functions for calculation of SVDs, and Eigen values 
 * 
 *
 * $Id: radius.cc,v 1.2 2002/10/26 20:55:49 mdsuresh Exp $
 *
 * Copyright (C) 2002 Suresh kumar Devanathan <mdsuresh@yahoo.com>
 * 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Suggestions:          blitz-dev@oonumerics.org
 * Bugs:                 blitz-bugs@oonumerics.org
 *
 * For more information, please see the Blitz++ Home Page:
 *    http://oonumerics.org/blitz/
 *
 ***************************************************************************
 * $Log: radius.cc,v $
 * Revision 1.0  2002/10/26 20:22:49  mdsuresh
 * Updated copyright date in headers.
 **/
 
#ifndef _VT_FUNCTION_RADIUS_CC
#define _VT_FUNCTION_RADIUS_CC

#ifndef _VT_PACK_H
#error the implementation of Helper radius function requires inclusion of <blitz/alg/port.h> \
       prior to the inclusion of this file.
#endif


namespace _VT_Pack  {
	namespace Helper {
		template<class T>
			T Radius(T u, T v)
		{
			T  Au, Av, Aw;
			Au = _VT_abs(u);
			Av = _VT_abs(v);
			if (Au > Av)
			{
				Aw = Av / Au;
				return (Au * _VT_sqrt(1. + Aw * Aw));
			} 
			else  {
				if (Av)
				{
					Aw = Au / Av;
					return (Av * _VT_sqrt(1. + Aw * Aw));
				} else
					return 0.0;
			}
		}



	}
}

#endif

