/***************************************************************************
 * blitz/member.h    Definition of the _member<P_numtype, N_rank> class
 *
 * $Id: member.h,v 1.10 2002/10/24 22:12:49 mdsuresh Exp $
 *
 * Copyright (C) 2002 Suresh kumar Devanathan <mdsuresh@yahoo.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Suggestions:          blitz-dev@oonumerics.org
 * Bugs:                 blitz-bugs@oonumerics.org
 *
 * For more information, please see the Blitz++ Home Page:
 *    http://oonumerics.org/blitz/
 *
 ***************************************************************************
 * $Log: member.h,v $
 * Revision 1.0
 * implemented _member
 */

#ifndef  _BZ_MEMBER_SPECIALIZATION_H
#define  _BZ_MEMBER_SPECIALIZATION_H

BZ_NAMESPACE(blitz)

template<class T, int n> class Array;
template<class T, int n, bool _adelete>
struct _member {
public:
	struct T_export
	{
		T_export(Array<T,n> _m) {
		}

		T_export() {

		}

		void set(Array<T,n>) {
		}

	};

};

BZ_NAMESPACE_END



#define BEGIN_EXPOSE_BLOCK(structure, component_type) BZ_NAMESPACE(blitz) \
	template<int n, bool _adelete>  \
struct _member< structure , n ,  _adelete> {  \
public: \
struct  T_export  {  \
	typedef structure T_numtype;   \
	typedef component_type T_comptype;\
	Array<T_numtype, n> * arr_;  \
	T_numtype t_;\
	T_export(Array<T_numtype,  n>* arr) : arr_(arr) \
{  } \
	T_export(): arr_(NULL)  {} \
	void set(Array<T_numtype, n>* arr) { \
	arr_= arr;  \
	} \
protected:               \
	inline void free() { if(_adelete) delete this; } \
	inline int locate(T_comptype& t) { \
	return  int( size_t(& t)  - size_t(&t_)) / sizeof(T_comptype);   \
	} \
public:

//while(   (  (T_component*) &member ) != 
//      ( ((T_component*) &t) + m)  ) m++; 
// return m; 
// \ 
// public: 


#define EXPOSE_MEMBER(member)    \
	Array<T_comptype, n>  member() { \
	Array<T_numtype,n>*  arr = arr_; \
	free(); \
	return  arr->extractComponent( T_comptype(),  \
	locate(  t_.##member)  ,  \
	sizeof(T_numtype)/ sizeof(T_comptype) );\
	} 


#define END_EXPOSE_BLOCK }; \
};   \
	BZ_NAMESPACE_END 



#define EXPOSE_STRUCTURE_C1(structure, component_type, m1 ) \
	BEGIN_EXPOSE_BLOCK(structure, component_type) \
	EXPOSE_MEMBER(m1) \
	END_EXPOSE_BLOCK

#define EXPOSE_STRUCTURE_C2(structure, component_type, m1, m2 ) \
	BEGIN_EXPOSE_BLOCK(structure, component_type) \
	EXPOSE_MEMBER(m1) \
	EXPOSE_MEMBER(m2) \
	END_EXPOSE_BLOCK         

#define EXPOSE_STRUCTURE_C3(structure, component_type, m1, m2 , m3) \
	BEGIN_EXPOSE_BLOCK(structure, component_type) \
	EXPOSE_MEMBER(m1) \
	EXPOSE_MEMBER(m2) \
	EXPOSE_MEMBER(m3) \
	END_EXPOSE_BLOCK      


#define EXPOSE_STRUCTURE_C4(structure, component_type, m1, m2 , m3, m4) \
	BEGIN_EXPOSE_BLOCK(structure, component_type) \
	EXPOSE_MEMBER(m1) \
	EXPOSE_MEMBER(m2) \
	EXPOSE_MEMBER(m3) \
	EXPOSE_MEMBER(m4) \
	END_EXPOSE_BLOCK

#define EXPOSE_STRUCTURE_C5(structure, component_type, m1, m2 , m3, m4, m5) \
	BEGIN_EXPOSE_BLOCK(structure, component_type) \
	EXPOSE_MEMBER(m1) \
	EXPOSE_MEMBER(m2) \
	EXPOSE_MEMBER(m3) \
	EXPOSE_MEMBER(m4) \
	EXPOSE_MEMBER(m5) \
	END_EXPOSE_BLOCK 


#define EXPOSE_STRUCTURE_C6(structure, component_type, m1, m2 , m3, m4, m5, m6) \
	BEGIN_EXPOSE_BLOCK(structure, component_type) \
	EXPOSE_MEMBER(m1) \
	EXPOSE_MEMBER(m2) \
	EXPOSE_MEMBER(m3) \
	EXPOSE_MEMBER(m4) \
	EXPOSE_MEMBER(m5) \
	EXPOSE_MEMBER(m6) \
	END_EXPOSE_BLOCK   



#endif // _BZ_MEMBER_SPECIALIZATION_H
