#include "all.h"

void nodecopy(int to, int from)
{ /* nodecopy */
  int i, gate;

  if (scircuit[from]->inputs != NULL && to > num_pi + num_dff)
    {
      circuit[to]->inputs = make_ilist(scircuit[from]->inputs[0]);
      totalcktmemory += (scircuit[from]->inputs[0]+1)*sizeof(int);
      circuit[to]->inputs[0] = 0;
      loop_through_ilist(scircuit[from]->inputs, i, gate)
	add_to_itail(circuit[to]->inputs, gate);
      circuit[to]->inputs[0] = scircuit[from]->inputs[0];
    }

  if(scircuit[from]->outputs != NULL && to <= gatecnt)
    {
      circuit[to]->outputs = make_ilist(scircuit[from]->outputs[0]);
      totalcktmemory += (scircuit[from]->outputs[0]+1)*sizeof(int);
      circuit[to]->outputs[0] = 0;
      loop_through_ilist(scircuit[from]->outputs, i, gate)
	add_to_itail(circuit[to]->outputs, gate);
      circuit[to]->outputs[0] = scircuit[from]->outputs[0];
    }

  circuit[to]->funct = scircuit[from]->funct;

} /* nodecopy */

/*
 * Function:
 *   Initialize the entire circuit graph
 * Input:
 *   ckt  - a pointer to the circuit graph
 *   size - number of nodes in the circuit graph
 * Return:
 *   none
 */

void init_node (nodes *ckt, /* a pointer to the circuit graph */
		int   size) /* size of the circuit graph */
{ /* init_node */
  int i;
  for (i=0;i<=size;i++)
    {
      ckt[i]->inputs           = NULL; 
      ckt[i]->outputs	       = NULL;
      
      ckt[i]->funct	       = 0;

      ckt[i]->fflag	       = false;
      ckt[i]->tflag	       = false; 
      ckt[i]->fu.flags	       = false;

      ckt[i]->labeling_word[0] = 0;
      ckt[i]->labeling_word[1] = 0;
      ckt[i]->aflist	       = NULL;
      ckt[i]->lines[0]	       = NULL;   
      ckt[i]->lines[1]	       = NULL;   
    }
} /* init_node */
