#include "all.h"

void readfaults (char * faultfile)
{ /* readfaults */
  FILE *tf, *fp2;
  int  scnt;
  //int  from, to, sa;
  NODE *from;
  NODE *to;
  int j,k;
  char line[1024];
 /* Figure out the fault list size */

  tf=fopen(faultfile,"r");
  if (tf==NULL)
    {
      fprintf(resultsout, "Unable to count lines in fault file %s.\n",
	      faultfile);
      exit(-4);
    }
  else
    {
      faultcnt=0;
      while(fgets(line,1024,tf))
	faultcnt++;
    }
  fclose(tf);

/* Allocate the fault list */

  faultlist = (faults *) calloc((faultcnt+1), sizeof(faults));
  tmpdetected = (int *) calloc((faultcnt+1), sizeof(int));
  totalcktmemory += (faultcnt+1)*(sizeof(faults)+sizeof(int));

  fp2 = fopen(faultfile, "r");
  if (fp2 == NULL)
    {
      printf("Failed to open faults file %s. Abort.\n", faultfile);
      fprintf(resultsout, "Failed to open faults file %s\n", faultfile);
      exit(-1);
    }
  /* Initial the goodstate to all 'X's  -J.ZHANG */
  goodstate = (int *)calloc(num_dff, sizeof(int));
  tmpgoodstate = (int *)calloc(num_dff, sizeof(int));
  for(k=0;k<num_dff;k++)
    {
      goodstate[k] = 'X';
      tmpgoodstate[k] = 'X';
    }
  totalsfsimmemory += (num_dff)*2*sizeof(int);
  
  j = 0;
  while ((scnt = fscanf(fp2, "%d%d%d", &from, &to, &sa)) != EOF)
    {
      if(scircuit[from]->funct != po)
	{
	  j++;
	  faultlist[j]->from = from;
	  faultlist[j]->to = to;
	  faultlist[j]->sa = sa;
	  faultlist[j]->flag = false;
	  faultlist[j]->tmp_flag = false;
	  faultlist[j]->state = (int *)calloc(num_dff, sizeof(int));
	  faultlist[j]->tmp_state = (int *)calloc(num_dff, sizeof(int));
          for(k=0;k<num_dff;k++)
	    {	
	      (faultlist[j]->state)[k] = 'X';
	      (faultlist[j]->tmp_state)[k] = 'X';
	    }
	  totalsfsimmemory += (num_dff)*2*sizeof(int);
	}
      else
	{
	  printf("Wrong from gate in faults file %s, line %d. Skip.\n", 
		 faultfile,j+1);
	  fprintf(resultsout,
		  "Wrong from gate in faults file %s, line %d. Skip.\n", 
		  faultfile,j+1);
	}
    }

/*
#ifdef DEBUG
  printfaultlist();
#endif
*/
} /* readfaults */

void printfaultlist(void)
{ /* printfaultlist */
  int i;

  fprintf(resultsout,"faultlist:\n");
  for(i=1;i<=faultcnt;i++)
    fprintf(resultsout,"%d %d %d\n",get_from(i),get_to(i),get_sa(i));
} /* printfaultlist */







